


<!DOCTYPE html>
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    
    
    <meta http-equiv="X-UA-Compatible" content="IE=emulateIE7" />
    <title>Coverage for resources/Local.py: 38%</title>
    <link rel="stylesheet" href="style.css" type="text/css">
    
    <script type="text/javascript" src="jquery.min.js"></script>
    <script type="text/javascript" src="jquery.hotkeys.js"></script>
    <script type="text/javascript" src="jquery.isonscreen.js"></script>
    <script type="text/javascript" src="coverage_html.js"></script>
    <script type="text/javascript">
        jQuery(document).ready(coverage.pyfile_ready);
    </script>
</head>
<body class="pyfile">

<div id="header">
    <div class="content">
        <h1>Coverage for <b>resources/Local.py</b> :
            <span class="pc_cov">38%</span>
        </h1>

        <img id="keyboard_icon" src="keybd_closed.png" alt="Show keyboard shortcuts" />

        <h2 class="stats">
            52 statements &nbsp;
            <span class="run hide_run shortkey_r button_toggle_run">20 run</span>
            <span class="mis shortkey_m button_toggle_mis">32 missing</span>
            <span class="exc shortkey_x button_toggle_exc">0 excluded</span>

            
        </h2>
    </div>
</div>

<div class="help_panel">
    <img id="panel_icon" src="keybd_open.png" alt="Hide keyboard shortcuts" />
    <p class="legend">Hot-keys on this page</p>
    <div>
    <p class="keyhelp">
        <span class="key">r</span>
        <span class="key">m</span>
        <span class="key">x</span>
        <span class="key">p</span> &nbsp; toggle line displays
    </p>
    <p class="keyhelp">
        <span class="key">j</span>
        <span class="key">k</span> &nbsp; next/prev highlighted chunk
    </p>
    <p class="keyhelp">
        <span class="key">0</span> &nbsp; (zero) top of page
    </p>
    <p class="keyhelp">
        <span class="key">1</span> &nbsp; (one) first highlighted chunk
    </p>
    </div>
</div>

<div id="source">
    <table>
        <tr>
            <td class="linenos">
<p id="n1" class="stm run hide_run"><a href="#n1">1</a></p>
<p id="n2" class="pln"><a href="#n2">2</a></p>
<p id="n3" class="stm run hide_run"><a href="#n3">3</a></p>
<p id="n4" class="stm run hide_run"><a href="#n4">4</a></p>
<p id="n5" class="stm run hide_run"><a href="#n5">5</a></p>
<p id="n6" class="pln"><a href="#n6">6</a></p>
<p id="n7" class="stm run hide_run"><a href="#n7">7</a></p>
<p id="n8" class="stm run hide_run"><a href="#n8">8</a></p>
<p id="n9" class="stm run hide_run"><a href="#n9">9</a></p>
<p id="n10" class="stm run hide_run"><a href="#n10">10</a></p>
<p id="n11" class="pln"><a href="#n11">11</a></p>
<p id="n12" class="stm run hide_run"><a href="#n12">12</a></p>
<p id="n13" class="pln"><a href="#n13">13</a></p>
<p id="n14" class="pln"><a href="#n14">14</a></p>
<p id="n15" class="stm run hide_run"><a href="#n15">15</a></p>
<p id="n16" class="stm run hide_run"><a href="#n16">16</a></p>
<p id="n17" class="stm run hide_run"><a href="#n17">17</a></p>
<p id="n18" class="pln"><a href="#n18">18</a></p>
<p id="n19" class="stm mis"><a href="#n19">19</a></p>
<p id="n20" class="stm mis"><a href="#n20">20</a></p>
<p id="n21" class="stm mis"><a href="#n21">21</a></p>
<p id="n22" class="pln"><a href="#n22">22</a></p>
<p id="n23" class="stm run hide_run"><a href="#n23">23</a></p>
<p id="n24" class="stm run hide_run"><a href="#n24">24</a></p>
<p id="n25" class="stm run hide_run"><a href="#n25">25</a></p>
<p id="n26" class="stm run hide_run"><a href="#n26">26</a></p>
<p id="n27" class="pln"><a href="#n27">27</a></p>
<p id="n28" class="stm mis"><a href="#n28">28</a></p>
<p id="n29" class="stm mis"><a href="#n29">29</a></p>
<p id="n30" class="stm mis"><a href="#n30">30</a></p>
<p id="n31" class="stm mis"><a href="#n31">31</a></p>
<p id="n32" class="stm mis"><a href="#n32">32</a></p>
<p id="n33" class="stm mis"><a href="#n33">33</a></p>
<p id="n34" class="stm mis"><a href="#n34">34</a></p>
<p id="n35" class="stm mis"><a href="#n35">35</a></p>
<p id="n36" class="stm mis"><a href="#n36">36</a></p>
<p id="n37" class="stm mis"><a href="#n37">37</a></p>
<p id="n38" class="stm mis"><a href="#n38">38</a></p>
<p id="n39" class="stm mis"><a href="#n39">39</a></p>
<p id="n40" class="stm mis"><a href="#n40">40</a></p>
<p id="n41" class="pln"><a href="#n41">41</a></p>
<p id="n42" class="pln"><a href="#n42">42</a></p>
<p id="n43" class="stm run hide_run"><a href="#n43">43</a></p>
<p id="n44" class="stm run hide_run"><a href="#n44">44</a></p>
<p id="n45" class="stm run hide_run"><a href="#n45">45</a></p>
<p id="n46" class="pln"><a href="#n46">46</a></p>
<p id="n47" class="stm mis"><a href="#n47">47</a></p>
<p id="n48" class="stm mis"><a href="#n48">48</a></p>
<p id="n49" class="stm mis"><a href="#n49">49</a></p>
<p id="n50" class="stm mis"><a href="#n50">50</a></p>
<p id="n51" class="stm mis"><a href="#n51">51</a></p>
<p id="n52" class="pln"><a href="#n52">52</a></p>
<p id="n53" class="stm run hide_run"><a href="#n53">53</a></p>
<p id="n54" class="stm mis"><a href="#n54">54</a></p>
<p id="n55" class="stm mis"><a href="#n55">55</a></p>
<p id="n56" class="stm mis"><a href="#n56">56</a></p>
<p id="n57" class="stm mis"><a href="#n57">57</a></p>
<p id="n58" class="stm mis"><a href="#n58">58</a></p>
<p id="n59" class="stm mis"><a href="#n59">59</a></p>
<p id="n60" class="stm mis"><a href="#n60">60</a></p>
<p id="n61" class="stm mis"><a href="#n61">61</a></p>
<p id="n62" class="stm mis"><a href="#n62">62</a></p>
<p id="n63" class="stm mis"><a href="#n63">63</a></p>
<p id="n64" class="stm mis"><a href="#n64">64</a></p>

            </td>
            <td class="text">
<p id="t1" class="stm run hide_run"><span class="key">import</span> <span class="nam">sys</span><span class="strut">&nbsp;</span></p>
<p id="t2" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t3" class="stm run hide_run"><span class="key">import</span> <span class="nam">flask</span><span class="strut">&nbsp;</span></p>
<p id="t4" class="stm run hide_run"><span class="key">from</span> <span class="nam">flask_restplus</span> <span class="key">import</span> <span class="nam">abort</span><span class="op">,</span> <span class="nam">Namespace</span><span class="strut">&nbsp;</span></p>
<p id="t5" class="stm run hide_run"><span class="key">from</span> <span class="nam">sqlalchemy</span><span class="op">.</span><span class="nam">exc</span> <span class="key">import</span> <span class="nam">DatabaseError</span><span class="strut">&nbsp;</span></p>
<p id="t6" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t7" class="stm run hide_run"><span class="key">from</span> <span class="nam">app</span> <span class="key">import</span> <span class="nam">db</span><span class="op">,</span> <span class="nam">Resource</span><span class="op">,</span> <span class="nam">request</span><span class="strut">&nbsp;</span></p>
<p id="t8" class="stm run hide_run"><span class="key">from</span> <span class="nam">http</span> <span class="key">import</span> <span class="nam">HTTPStatus</span><span class="strut">&nbsp;</span></p>
<p id="t9" class="stm run hide_run"><span class="key">from</span> <span class="nam">models</span> <span class="key">import</span> <span class="nam">Local</span><span class="strut">&nbsp;</span></p>
<p id="t10" class="stm run hide_run"><span class="key">from</span> <span class="nam">auth</span><span class="op">.</span><span class="nam">authenticate</span> <span class="key">import</span> <span class="nam">authenticate_or_abort</span><span class="strut">&nbsp;</span></p>
<p id="t11" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t12" class="stm run hide_run"><span class="nam">local_ns</span> <span class="op">=</span> <span class="nam">Namespace</span><span class="op">(</span><span class="nam">name</span><span class="op">=</span><span class="str">"local"</span><span class="op">,</span> <span class="nam">description</span><span class="op">=</span><span class="str">"Rotas relacionadas a locals"</span><span class="op">,</span> <span class="nam">path</span><span class="op">=</span><span class="str">"/local"</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t13" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t14" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t15" class="stm run hide_run"><span class="op">@</span><span class="nam">local_ns</span><span class="op">.</span><span class="nam">route</span><span class="op">(</span><span class="str">"/"</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t16" class="stm run hide_run"><span class="key">class</span> <span class="nam">LocaisResource</span><span class="op">(</span><span class="nam">Resource</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t17" class="stm run hide_run">    <span class="op">@</span><span class="nam">local_ns</span><span class="op">.</span><span class="nam">marshal_with</span><span class="op">(</span><span class="nam">Local</span><span class="op">.</span><span class="nam">ResponseModel</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t18" class="pln">    <span class="key">def</span> <span class="nam">get</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t19" class="stm mis">        <span class="nam">local</span> <span class="op">=</span> <span class="nam">Local</span><span class="op">.</span><span class="nam">query</span><span class="op">.</span><span class="nam">all</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t20" class="stm mis">        <span class="nam">authenticate_or_abort</span><span class="op">(</span><span class="nam">flask</span><span class="op">.</span><span class="nam">request</span><span class="op">.</span><span class="nam">args</span><span class="op">.</span><span class="nam">get</span><span class="op">,</span> <span class="nam">abort</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t21" class="stm mis">        <span class="key">return</span> <span class="nam">local</span><span class="strut">&nbsp;</span></p>
<p id="t22" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t23" class="stm run hide_run">    <span class="op">@</span><span class="nam">local_ns</span><span class="op">.</span><span class="nam">expect</span><span class="op">(</span><span class="nam">Local</span><span class="op">.</span><span class="nam">RequestModel</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t24" class="stm run hide_run">    <span class="op">@</span><span class="nam">local_ns</span><span class="op">.</span><span class="nam">marshal_with</span><span class="op">(</span><span class="nam">Local</span><span class="op">.</span><span class="nam">ResponseModel</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t25" class="stm run hide_run">    <span class="op">@</span><span class="nam">local_ns</span><span class="op">.</span><span class="nam">response</span><span class="op">(</span><span class="nam">code</span><span class="op">=</span><span class="nam">HTTPStatus</span><span class="op">.</span><span class="nam">UNAUTHORIZED</span><span class="op">,</span> <span class="nam">description</span><span class="op">=</span><span class="str">""</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t26" class="stm run hide_run">    <span class="op">@</span><span class="nam">local_ns</span><span class="op">.</span><span class="nam">response</span><span class="op">(</span><span class="nam">code</span><span class="op">=</span><span class="nam">HTTPStatus</span><span class="op">.</span><span class="nam">BAD_REQUEST</span><span class="op">,</span> <span class="nam">description</span><span class="op">=</span><span class="str">""</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t27" class="pln">    <span class="key">def</span> <span class="nam">post</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t28" class="stm mis">        <span class="nam">local_json</span> <span class="op">=</span> <span class="nam">request</span><span class="op">.</span><span class="nam">get_json</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t29" class="stm mis">        <span class="nam">authenticate_or_abort</span><span class="op">(</span><span class="nam">flask</span><span class="op">.</span><span class="nam">request</span><span class="op">.</span><span class="nam">args</span><span class="op">.</span><span class="nam">get</span><span class="op">,</span> <span class="nam">abort</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t30" class="stm mis">        <span class="nam">local</span><span class="op">,</span> <span class="nam">err</span> <span class="op">=</span> <span class="nam">Local</span><span class="op">.</span><span class="nam">Schema</span><span class="op">(</span><span class="op">)</span><span class="op">.</span><span class="nam">load</span><span class="op">(</span><span class="nam">local_json</span><span class="op">,</span> <span class="nam">session</span><span class="op">=</span><span class="nam">db</span><span class="op">.</span><span class="nam">session</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t31" class="stm mis">        <span class="key">if</span> <span class="nam">err</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t32" class="stm mis">            <span class="nam">print</span><span class="op">(</span><span class="nam">err</span><span class="op">,</span> <span class="nam">file</span><span class="op">=</span><span class="nam">sys</span><span class="op">.</span><span class="nam">stderr</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t33" class="stm mis">            <span class="nam">abort</span><span class="op">(</span><span class="nam">HTTPStatus</span><span class="op">.</span><span class="nam">BAD_REQUEST</span><span class="op">,</span> <span class="nam">err</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t34" class="stm mis">        <span class="nam">db</span><span class="op">.</span><span class="nam">session</span><span class="op">.</span><span class="nam">add</span><span class="op">(</span><span class="nam">local</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t35" class="stm mis">        <span class="key">try</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t36" class="stm mis">            <span class="nam">db</span><span class="op">.</span><span class="nam">session</span><span class="op">.</span><span class="nam">commit</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t37" class="stm mis">        <span class="key">except</span> <span class="nam">DatabaseError</span> <span class="key">as</span> <span class="nam">e</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t38" class="stm mis">            <span class="nam">print</span><span class="op">(</span><span class="nam">e</span><span class="op">,</span> <span class="nam">file</span><span class="op">=</span><span class="nam">sys</span><span class="op">.</span><span class="nam">stderr</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t39" class="stm mis">            <span class="nam">abort</span><span class="op">(</span><span class="nam">HTTPStatus</span><span class="op">.</span><span class="nam">BAD_REQUEST</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t40" class="stm mis">        <span class="key">return</span> <span class="nam">Local</span><span class="op">.</span><span class="nam">query</span><span class="op">.</span><span class="nam">order_by</span><span class="op">(</span><span class="nam">Local</span><span class="op">.</span><span class="nam">id</span><span class="op">.</span><span class="nam">desc</span><span class="op">(</span><span class="op">)</span><span class="op">)</span><span class="op">.</span><span class="nam">first</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t41" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t42" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t43" class="stm run hide_run"><span class="op">@</span><span class="nam">local_ns</span><span class="op">.</span><span class="nam">route</span><span class="op">(</span><span class="str">"/&lt;id>"</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t44" class="stm run hide_run"><span class="key">class</span> <span class="nam">LocalResource</span><span class="op">(</span><span class="nam">Resource</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t45" class="stm run hide_run">    <span class="op">@</span><span class="nam">local_ns</span><span class="op">.</span><span class="nam">marshal_with</span><span class="op">(</span><span class="nam">Local</span><span class="op">.</span><span class="nam">ResponseModel</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t46" class="pln">    <span class="key">def</span> <span class="nam">get</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">id</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t47" class="stm mis">        <span class="nam">local</span> <span class="op">=</span> <span class="nam">Local</span><span class="op">.</span><span class="nam">query</span><span class="op">.</span><span class="nam">get</span><span class="op">(</span><span class="nam">id</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t48" class="stm mis">        <span class="nam">authenticate_or_abort</span><span class="op">(</span><span class="nam">flask</span><span class="op">.</span><span class="nam">request</span><span class="op">.</span><span class="nam">args</span><span class="op">.</span><span class="nam">get</span><span class="op">,</span> <span class="nam">abort</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t49" class="stm mis">        <span class="key">if</span> <span class="nam">local</span> <span class="key">is</span> <span class="key">None</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t50" class="stm mis">            <span class="nam">abort</span><span class="op">(</span><span class="nam">HTTPStatus</span><span class="op">.</span><span class="nam">NOT_FOUND</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t51" class="stm mis">        <span class="key">return</span> <span class="nam">local</span><span class="strut">&nbsp;</span></p>
<p id="t52" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t53" class="stm run hide_run">    <span class="key">def</span> <span class="nam">delete</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">id</span><span class="op">)</span><span class="op">:</span>  <span class="com"># This endpoint should not exist (There is no way of checking authorization)</span><span class="strut">&nbsp;</span></p>
<p id="t54" class="stm mis">        <span class="nam">abort</span><span class="op">(</span><span class="nam">HTTPStatus</span><span class="op">.</span><span class="nam">NOT_IMPLEMENTED</span><span class="op">,</span> <span class="str">"This endpoint is a WIP (Working In Progress). Come back later!"</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t55" class="stm mis">        <span class="nam">local</span> <span class="op">=</span> <span class="nam">Local</span><span class="op">.</span><span class="nam">query</span><span class="op">.</span><span class="nam">get</span><span class="op">(</span><span class="nam">id</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t56" class="stm mis">        <span class="nam">authenticate_or_abort</span><span class="op">(</span><span class="nam">flask</span><span class="op">.</span><span class="nam">request</span><span class="op">.</span><span class="nam">args</span><span class="op">.</span><span class="nam">get</span><span class="op">,</span> <span class="nam">abort</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t57" class="stm mis">        <span class="key">if</span> <span class="nam">local</span> <span class="key">is</span> <span class="key">None</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t58" class="stm mis">            <span class="nam">abort</span><span class="op">(</span><span class="nam">HTTPStatus</span><span class="op">.</span><span class="nam">NOT_FOUND</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t59" class="stm mis">        <span class="nam">db</span><span class="op">.</span><span class="nam">session</span><span class="op">.</span><span class="nam">delete</span><span class="op">(</span><span class="nam">local</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t60" class="stm mis">        <span class="key">try</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t61" class="stm mis">            <span class="nam">db</span><span class="op">.</span><span class="nam">session</span><span class="op">.</span><span class="nam">commit</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t62" class="stm mis">        <span class="key">except</span> <span class="nam">DatabaseError</span> <span class="key">as</span> <span class="nam">e</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t63" class="stm mis">            <span class="nam">print</span><span class="op">(</span><span class="nam">e</span><span class="op">,</span> <span class="nam">file</span><span class="op">=</span><span class="nam">sys</span><span class="op">.</span><span class="nam">stderr</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t64" class="stm mis">            <span class="nam">abort</span><span class="op">(</span><span class="nam">HTTPStatus</span><span class="op">.</span><span class="nam">BAD_REQUEST</span><span class="op">)</span><span class="strut">&nbsp;</span></p>

            </td>
        </tr>
    </table>
</div>

<div id="footer">
    <div class="content">
        <p>
            <a class="nav" href="index.html">&#xab; index</a> &nbsp; &nbsp; <a class="nav" href="https://coverage.readthedocs.io">coverage.py v4.5.4</a>,
            created at 2019-09-18 17:47
        </p>
    </div>
</div>

</body>
</html>
